import { Any } from "../../../google/protobuf/any";
import { BinaryReader, BinaryWriter } from "../../../binary";
import { DeepPartial } from "../../../helpers";
/**
 * LegacyAminoPubKey specifies a public key type
 * which nests multiple public keys and a threshold,
 * it uses legacy amino address rules.
 * @name LegacyAminoPubKey
 * @package cosmos.crypto.multisig
 * @see proto type: cosmos.crypto.multisig.LegacyAminoPubKey
 */
export interface LegacyAminoPubKey {
    threshold: number;
    publicKeys: Any[];
}
/**
 * LegacyAminoPubKey specifies a public key type
 * which nests multiple public keys and a threshold,
 * it uses legacy amino address rules.
 * @name LegacyAminoPubKey
 * @package cosmos.crypto.multisig
 * @see proto type: cosmos.crypto.multisig.LegacyAminoPubKey
 */
export declare const LegacyAminoPubKey: {
    typeUrl: string;
    aminoType: string;
    encode(message: LegacyAminoPubKey, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): LegacyAminoPubKey;
    fromPartial(object: DeepPartial<LegacyAminoPubKey>): LegacyAminoPubKey;
};
