import { SimulateRequest, SimulateResponse, GetTxRequest, GetTxResponse, BroadcastTxRequest, BroadcastTxResponse, GetTxsEventRequest, GetTxsEventResponse, GetBlockWithTxsRequest, GetBlockWithTxsResponse, TxDecodeRequest, TxDecodeResponse, TxEncodeRequest, TxEncodeResponse, TxEncodeAminoRequest, TxEncodeAminoResponse, TxDecodeAminoRequest, TxDecodeAminoResponse } from "./service";
/**
 * Simulate simulates executing a transaction for estimating gas usage.
 * @name getSimulate
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.Simulate
 */
export declare const getSimulate: (client: import("../../../helper-func-types").EndpointOrRpc, request: SimulateRequest) => Promise<SimulateResponse>;
/**
 * GetTx fetches a tx by hash.
 * @name getTx
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.GetTx
 */
export declare const getTx: (client: import("../../../helper-func-types").EndpointOrRpc, request: GetTxRequest) => Promise<GetTxResponse>;
/**
 * BroadcastTx broadcast transaction.
 * @name getBroadcastTx
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.BroadcastTx
 */
export declare const getBroadcastTx: (client: import("../../../helper-func-types").EndpointOrRpc, request: BroadcastTxRequest) => Promise<BroadcastTxResponse>;
/**
 * GetTxsEvent fetches txs by event.
 * @name getTxsEvent
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.GetTxsEvent
 */
export declare const getTxsEvent: (client: import("../../../helper-func-types").EndpointOrRpc, request: GetTxsEventRequest) => Promise<GetTxsEventResponse>;
/**
 * GetBlockWithTxs fetches a block with decoded txs.
 * @name getBlockWithTxs
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.GetBlockWithTxs
 */
export declare const getBlockWithTxs: (client: import("../../../helper-func-types").EndpointOrRpc, request: GetBlockWithTxsRequest) => Promise<GetBlockWithTxsResponse>;
/**
 * TxDecode decodes the transaction.
 * @name getTxDecode
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.TxDecode
 */
export declare const getTxDecode: (client: import("../../../helper-func-types").EndpointOrRpc, request: TxDecodeRequest) => Promise<TxDecodeResponse>;
/**
 * TxEncode encodes the transaction.
 * @name getTxEncode
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.TxEncode
 */
export declare const getTxEncode: (client: import("../../../helper-func-types").EndpointOrRpc, request: TxEncodeRequest) => Promise<TxEncodeResponse>;
/**
 * TxEncodeAmino encodes an Amino transaction from JSON to encoded bytes.
 * @name getTxEncodeAmino
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.TxEncodeAmino
 */
export declare const getTxEncodeAmino: (client: import("../../../helper-func-types").EndpointOrRpc, request: TxEncodeAminoRequest) => Promise<TxEncodeAminoResponse>;
/**
 * TxDecodeAmino decodes an Amino transaction from encoded bytes to JSON.
 * @name getTxDecodeAmino
 * @package cosmos.tx.v1beta1
 * @see proto service: cosmos.tx.v1beta1.TxDecodeAmino
 */
export declare const getTxDecodeAmino: (client: import("../../../helper-func-types").EndpointOrRpc, request: TxDecodeAminoRequest) => Promise<TxDecodeAminoResponse>;
