import { BinaryReader, BinaryWriter } from "../../binary";
import { DeepPartial } from "../../helpers";
/**
 * PublicKey defines the keys available for use with Validators
 * @name PublicKey
 * @package tendermint.crypto
 * @see proto type: tendermint.crypto.PublicKey
 */
export interface PublicKey {
    ed25519?: Uint8Array;
    secp256k1?: Uint8Array;
}
/**
 * PublicKey defines the keys available for use with Validators
 * @name PublicKey
 * @package tendermint.crypto
 * @see proto type: tendermint.crypto.PublicKey
 */
export declare const PublicKey: {
    typeUrl: string;
    encode(message: PublicKey, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): PublicKey;
    fromPartial(object: DeepPartial<PublicKey>): PublicKey;
};
